/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ActionAuthorizationResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActionAuthorizationResponseInner{}

// ActionAuthorizationResponseInner struct for ActionAuthorizationResponseInner
type ActionAuthorizationResponseInner struct {
	Id      *int32  `json:"id,omitempty"`
	Service *string `json:"service,omitempty"`
	Email   *string `json:"email,omitempty"`
}

// NewActionAuthorizationResponseInner instantiates a new ActionAuthorizationResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActionAuthorizationResponseInner() *ActionAuthorizationResponseInner {
	this := ActionAuthorizationResponseInner{}
	return &this
}

// NewActionAuthorizationResponseInnerWithDefaults instantiates a new ActionAuthorizationResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActionAuthorizationResponseInnerWithDefaults() *ActionAuthorizationResponseInner {
	this := ActionAuthorizationResponseInner{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *ActionAuthorizationResponseInner) GetId() int32 {
	if o == nil || IsNil(o.Id) {
		var ret int32
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActionAuthorizationResponseInner) GetIdOk() (*int32, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *ActionAuthorizationResponseInner) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given int32 and assigns it to the Id field.
func (o *ActionAuthorizationResponseInner) SetId(v int32) {
	o.Id = &v
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *ActionAuthorizationResponseInner) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActionAuthorizationResponseInner) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *ActionAuthorizationResponseInner) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *ActionAuthorizationResponseInner) SetService(v string) {
	o.Service = &v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *ActionAuthorizationResponseInner) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActionAuthorizationResponseInner) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *ActionAuthorizationResponseInner) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *ActionAuthorizationResponseInner) SetEmail(v string) {
	o.Email = &v
}

func (o ActionAuthorizationResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActionAuthorizationResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	return toSerialize, nil
}

type NullableActionAuthorizationResponseInner struct {
	value *ActionAuthorizationResponseInner
	isSet bool
}

func (v NullableActionAuthorizationResponseInner) Get() *ActionAuthorizationResponseInner {
	return v.value
}

func (v *NullableActionAuthorizationResponseInner) Set(val *ActionAuthorizationResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableActionAuthorizationResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableActionAuthorizationResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActionAuthorizationResponseInner(val *ActionAuthorizationResponseInner) *NullableActionAuthorizationResponseInner {
	return &NullableActionAuthorizationResponseInner{value: val, isSet: true}
}

func (v NullableActionAuthorizationResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActionAuthorizationResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
